#include "kicchip_leaf_helper.h"
//kicchip ide #include "kicchip_leaf_helper.bh"

// This file is using BASIC syntax so include header for commands & types
//kicchip ide #include "kicchip_basic.bh"
// Include header for Serial etc.
//kicchip ide #include "kicchip_library.bh"    

namespace ns_kicchip_leaf_helper
{
  //from header, only used internally now
  // update: moved to header for describe_to_iotleaf function
  //shared constexpr dim as word16 k_json_doc_size   {  100 } ;

  // ---------------------------------------------------------------------------
  /*
    {
      "type"  : _N_DATA
    , "id"     : N
    , "package"       : { "objtype"  : "_N_ERROR_
                        , "object"   : { }
                        }
    }
  */
  // ---------------------------------------------------------------------------

  // ---------------------------------------------------------------------------
  // returns 'true' if a_JsonDocument has required structures declared.
  // ---------------------------------------------------------------------------
  shared
  funcn as bool get_json_doc_header
  ( as JsonDocument refer_to a_JsonDocument
  )
  begin_block
    dim as bool my_result {false} ;
    if
    (
       a_JsonDocument [ k_json_fn_dat ]                 .isNull()
    || a_JsonDocument [ k_json_idx    ]                 .isNull()
    || a_JsonDocument [ k_json_pkg    ]                 .isNull()
    || a_JsonDocument [ k_json_pkg    ][ k_json_t_obj ] .isNull()
    || a_JsonDocument [ k_json_pkg    ][ k_json_obj   ] .isNull()
    )
    begin_block
      let my_result = false ;
      //debug send_json_doc (a_JsonDocument ) ;
      //Serial.println( " ** ERROR ** " );
    end_block
    return my_result ;
  end_block
  // ---------------------------------------------------------------------------

  // ---------------------------------------------------------------------------
  // builds required structure in 'a_JsonDocument'
  // ---------------------------------------------------------------------------
  shared
  funcn as JsonObject set_json_doc_header
  ( as JsonDocument refer_to a_JsonDocument
  , as byte                  a_type
  , as word32                a_id
  , as byte                  a_obj_type
  )
  begin_block
	  dim as  JsonObject my_node_object = a_JsonDocument.createNestedObject( "leaf" )  ;
		return my_node_object ;
	  /* pre mqtt
    let a_JsonDocument [ k_json_fn_dat ]  = a_type ;
    let a_JsonDocument [ k_json_idx    ]  = a_id   ;

    dim as JsonObject my_node_package = a_JsonDocument.createNestedObject( k_json_pkg ) ;
    let my_node_package[ k_json_t_obj  ] = a_obj_type ;
    dim as  JsonObject my_node_object = my_node_package.createNestedObject( k_json_obj )  ;

    return my_node_object ;
		*/
  end_block
  // ---------------------------------------------------------------------------


  // ---------------------------------------------------------------------------
  // sends document to Serial - note uses 'specific' Serial name
  // todo: allow user to change Serial name.
  // ---------------------------------------------------------------------------
  shared
  subroutine send_json_doc ( as JsonDocument refer_to a_JsonDocument )
  begin_block
    Serial.print ( k_start_marker ) ;
    serializeJson //
    //serializeJsonPretty
    ( a_JsonDocument
    , Serial
    )                     ;
    Serial.println ( k_end_marker ) ;
  end_block
  // ---------------------------------------------------------------------------

  // ---------------------------------------------------------------------------
  // prints json error message
    /*
    set_json_doc_header
    ( my_doc_send
    , k_type_data
    , 99
    , k_objtype_error
    )[k_json_err_msg] = a_message
    ;
    */
  // ---------------------------------------------------------------------------
  shared
  subroutine send_error
  ( as t_const_chars a_message
  , as char a_char_array[]
  )
  begin_block
    dim as StaticJsonDocument<k_json_doc_size> my_doc_send   ;

    dim as JsonObject my_JsonObject
    {
      set_json_doc_header
      ( my_doc_send
      , k_type_data
      , 99
      , k_objtype_error
      )
    }
    ;
    my_JsonObject[k_json_err_msg] = a_message ;
    my_JsonObject["chrs"] = a_char_array ;
    send_json_doc ( my_doc_send )                ;
  end_block
  // ---------------------------------------------------------------------------

}
// -----------------------------------------------------------------------------
