#pragma once

// This file is using BASIC syntax so include header for commands & types
#include "kicchip.h"  
//kicchip ide #include "kicchip_basic.bh"  

// -----------------------------------------------------------------------------
// Basic/C++ Specifications
// -----------------------------------------------------------------------------

#include "kic_json.h"
#define t_kic_static_json_doc StaticJsonDocument
#define t_kic_json_object JsonObject
//kicchip ide #include "lib_json.h"
namespace ns_kicchip_leaf_helper
{
  //++
  shared constexpr dim as word16 k_json_doc_size   {  100 } ;

  //shared constexpr dim as word16 k_json_doc_size   {  100 } ;

  unshared constexpr dim as char   k_start_marker    { '<'  } ;
  unshared constexpr dim as char   k_end_marker      { '>'  } ;

  // note: the is a kicchip predifined type that could be used instead.
  newtype as const char point_to t_const_chars ;

  #define k_json_fn_dat   "t_fd"
  #define k_json_idx      "idx"
  #define k_json_pkg      "pkg"
  #define k_json_t_obj    "t_obj"
  #define k_json_obj      "obj"
  #define k_json_err_msg  "err_msg"

  /*
  unshared constexpr dim as const char *  k_json_fn_dat  = "t_fd"    ;
  unshared constexpr dim as const char *  k_json_idx     = "idx"     ;
  unshared constexpr dim as const char *  k_json_pkg     = "pkg"     ;
  unshared constexpr dim as const char *  k_json_t_obj   = "t_obj"   ;
  unshared constexpr dim as const char *  k_json_obj     = "obj"     ;
  unshared constexpr dim as const char *  k_json_err_msg = "err_msg" ;
  */

  // avoid zero based values, in case null comes out at zero, until proven otherwise.
  // must match u_class_serial.pas
  shared constexpr dim as byte k_type_data        = 1 ;
  shared constexpr dim as byte k_objtype_readings = 2 ;
  shared constexpr dim as byte k_objtype_settings = 3 ;
  shared constexpr dim as byte k_objtype_error    = 4 ;
  shared constexpr dim as byte k_objtype_data_description    = 5 ;

  shared constexpr dim as byte k_type_fn          = 2 ;
  shared constexpr dim as byte k_objtype_get      = 1 ;
  shared constexpr dim as byte k_objtype_set      = 2 ;



  shared
  funcn as bool get_json_doc_header
  ( as JsonDocument refer_to a_JsonDocument
  //, as JsonObject   refer_to a_t_fd
  //, as JsonObject   refer_to a_idx
  //, as JsonObject   refer_to a_pkg
  //, as JsonObject   refer_to a_t_obj
  //, as JsonObject   refer_to a_obj
  )
  ;

  shared
  funcn as JsonObject set_json_doc_header
  ( as JsonDocument refer_to a_JsonDocument
  , as byte                  a_type
  , as word32                a_id
  , as byte                  a_obj_type
  )
  ;

  shared
  subroutine send_json_doc ( as JsonDocument refer_to a_JsonDocument )
  ;

  shared
  subroutine send_error
  ( as t_const_chars a_message
  , as char a_char_array[]
  )
  ;
}
// -----------------------------------------------------------------------------
